﻿package {
	
	import flash.geom.ColorTransform;	
	import flash.display.MovieClip;
	

	public class CardClip extends MovieClip {
		
		//onstage already:
		private var suit_mc:MovieClip;
		private var face_mc:MovieClip;
		
		public function CardClip( card:Card = null ) {
			
			if ( card == null ){
				card = new Card();
			}
			
			suit_mc = this["suit"];
			face_mc = this["num"];
			
			
			showAs ( card );
			
			
		}
		
		
		//=============== SHOW AS
		public function showAs ( whatCard:Card ):void{
			
			suit_mc.gotoAndStop( getFrameNumOfSuit( whatCard.suit ) );
			face_mc.gotoAndStop( getFrameNumOfFace( whatCard.face ) );
			
			//tint the face according to suit
			var ct:ColorTransform = new ColorTransform();
			ct.color = getColorOfSuit( whatCard.suit );
			face_mc.transform.colorTransform = ct;
			
		}
		
		
		//-------------- GET FRAME NUM OF SUIT
		private function getFrameNumOfSuit( whatSuit:String ):Number{
			
			var returnValue:Number = 0;
			
			switch( whatSuit ){
				
				case Card.SUIT_SPADE:
					returnValue = 1;
					break;
					
				case Card.SUIT_HEART:
					returnValue = 2;
					break;
					
				case Card.SUIT_DIAMOND:
					returnValue = 3;
					break;
					
				case Card.SUIT_CLUB:
					returnValue = 4;
					break;
					
			}
			
			return returnValue;
		}
		
		
		//-------------- GET FRAME NUM OF FACE
		private function getFrameNumOfFace( whatFace:String ):Number{
			
			var faceList:Array = [Card.FACE_ACE,
								  Card.FACE_TWO,
								  Card.FACE_THREE,
								  Card.FACE_FOUR,
								  Card.FACE_FIVE,
								  Card.FACE_SIX,
								  Card.FACE_SEVEN,
								  Card.FACE_EIGHT,
								  Card.FACE_NINE,
								  Card.FACE_TEN,
								  Card.FACE_JACK,
								  Card.FACE_QUEEN,
								  Card.FACE_KING    ];
			return faceList.indexOf( whatFace ) + 1;
								  
		}
		
		
		//--------------  GET COLOR OF SUIT
		private function getColorOfSuit(whatSuit:String ):Number{
			
			var returnValue:Number = 0;
			
			switch( whatSuit ){
				
				case Card.SUIT_SPADE:
					returnValue = 0x000000;
					break;
					
				case Card.SUIT_HEART:
					returnValue = 0x990000;
					break;
					
				case Card.SUIT_DIAMOND:
					returnValue = 0x990000;
					break;
					
				case Card.SUIT_CLUB:
					returnValue = 0x000000;
					break;
			}
			
			return returnValue;
			
		}
		
		
	}
}
