﻿package {

	public class Album {
		
		private var data:XML;
		private var songArray:Array;//of Song instances
		private var _duration:Number;
		
		function Album ( rawXML:XML ){
			//just hold on to the xml
			data = rawXML;
			
			
			//do this parsing once (instead of every time requested):
			songArray = new Array();
			
			_duration = 0;
			for each ( var song:XML in data.song ){
				var thisSong:Song = new Song( song );
				songArray.push (  thisSong  );
				_duration +=  thisSong.duration;
			}
			
		}
		
		
		
		public function get title():String{
			return data.@title;
		}
		public function get artist():String{
			return data.@artist;
		}
		public function get genre():String{
			return data.@genre;
		}
		public function get year():Number{
			return data.@year;
		}
		
		public function get duration():Number{
			return _duration;
		}
		
		
		public function get songs():Array{
			//because as Arrays are reference (not value) variables
			//it would be possible to modify the array if we just returned songArray
			//so, instead, I do split which basically clones the array (makes a copy "by value")
			//sort of like how a true copy of a file works vs. just making a shortcut/alias
			return songArray;
		}
		
	}
		
}